unit mini_file_utils;

interface

uses
  Windows, Messages, SysUtils, Commdlg, shlobj, activex;

const
  MAX_PATH = 1024;

// Open / Save Dialog
//function ShowOpenDialog(hOwner:HWND; Filter, InitDir: string): string;
//function ShowSaveDialog(hOwner:HWND; Filter, InitDir: string): string;
function OpenFolderDialog(var FolderPath: string): boolean;

function GetSpecialFolder(id: DWORD): string;

function WinDir:string;
function SysDir:string;
function TempDir:string;
function DesktopDir:string;
function SendToDir:string;
function StartUpDir:string;
function RecentDir:string;
function ProgramsDir:string;
function StartMenuDir:string;
function MyDocumentDir:string;
function FavoritesDir: string;
function MyMusicDir:string;
function MyPictureDir:string;
function FontsDir: string;
function ProgramFilesDir:string;

function RunAndWait(path: string; Hide: Boolean=False): Boolean;


implementation

uses unit_string, Classes;

const
  CSIDL_DESKTOP 		=$0000;//ufXNgbvvil[Xy[X̃[g\ztH_j
  CSIDL_INTERNET 		=$0001;//uInternet ExplorerviztH_j
  CSIDL_PROGRAMS 		=$0002;//uvOvit@CVXefBNgj
  CSIDL_CONTROLS 		=$0003;//uRg[ plviztH_j
  CSIDL_PRINTERS 		=$0004;//uv^viztH_j
  CSIDL_PERSONAL 		=$0005;//u}C hLgvit@CVXefBNgj
  CSIDL_FAVORITES 		=$0006;//uCɓvit@CVXefBNgj
  CSIDL_STARTUP 		=$0007;//uX^[gAbvvit@CVXefBNgj
  CSIDL_RECENT 		=$0008;//uŋߎgt@Cvit@CVXefBNgj
  CSIDL_SENDTO 		=$0009;//uSendTovit@CVXefBNgj
  CSIDL_BITBUCKET 		=$000a;//uݔviztH_j
  CSIDL_STARTMENU 		=$000b;//uX^[gj[vit@CVXefBNgj
  CSIDL_MYMUSIC 		=$000d;//u}C ~[WbNvit@CVXefBNgj
  CSIDL_DESKTOPDIRECTORY 		=$0010;//ufXNgbvṽt@CIuWFNgi[tH_it@CVXefBNgj
  CSIDL_DRIVES 		=$0011;//u}C Rs[^viztH_j
  CSIDL_NETWORK 		=$0012;//ulbg[NRs[^viztH_j
  CSIDL_NETHOOD 		=$0013;//uNetHoodvit@CVXefBNgj
  CSIDL_FONTS 		=$0014;//uFontsvitHg܂މztH_j
  CSIDL_TEMPLATES 		=$0015;//hLgev[gi[tH_it@CVXefBNgj
  CSIDL_COMMON_STARTMENU 		=$0016;//AllUsers ́uX^[gj[vit@CVXefBNgj
  CSIDL_COMMON_PROGRAMS 		=$0017;//AllUsers ́uvOvit@CVXefBNgj
  CSIDL_COMMON_STARTUP 		=$0018;//AllUsers ́uX^[gAbvvit@CVXefBNgj
  CSIDL_COMMON_DESKTOPDIRECTORY 		=$0019;//AllUsers ́ufXNgbvvit@CVXefBNgj
  CSIDL_APPDATA 		=$001a;//Version 4.71 ȍ~F uApplication Datavit@CVXefBNgj
  CSIDL_PRINTHOOD 		=$001b;//uv^vztH_ɂ郊NIuWFNgi[tH_it@CVXefBNgj
  CSIDL_LOCAL_APPDATA 		=$001c;//Version 5.0 ȍ~F uApplication Datavit@CVXefBNgj
  CSIDL_ALTSTARTUP 		=$001d;//񃍁[Jł́uX^[gAbvvit@CVXefBNgj
  CSIDL_COMMON_ALTSTARTUP 		=$001e;//񃍁[Jł AllUsers ́uX^[gAbvvit@CVXefBNgj
  CSIDL_COMMON_FAVORITES 		=$001f;//AllUsers ́uCɓviNTn̂݁jit@CVXefBNgj
  CSIDL_INTERNET_CACHE 		=$0020;//Version 4.72 ȍ~F C^[lbgꎞt@Ci[tH_it@CVXefBNgj
  CSIDL_COOKIES 		=$0021;//uCookiesvit@CVXefBNgj
  CSIDL_HISTORY 		=$0022;//uvit@CVXefBNgj
  CSIDL_COMMON_APPDATA 		=$0023;//Version 5.0 ȍ~F AllUsers ́uApplication Datavit@CVXefBNgj
  CSIDL_WINDOWS 		=$0024;//Version 5.0 ȍ~F Windows fBNg
  CSIDL_SYSTEM 		=$0025;//Version 5.0 ȍ~F Windows System fBNg
  CSIDL_PROGRAM_FILES 		=$0026;//Version 5.0 ȍ~F Program Files tH_
  CSIDL_MYPICTURES 		=$0027;//Version 5.0 ȍ~F My Pictures tH_it@CVXefBNgj
  CSIDL_PROFILE 		=$0028;//Version 5.0 ȍ~F profile tH_
  CSIDL_PROGRAM_FILES_COMMON 		=$002b;//Version 5.0 ȍ~GWindows 2000/XPF Program Files\Common
  CSIDL_COMMON_TEMPLATES 		=$002d;//Windows NT/2000/XPF AllUsers ̃hLgev[gi[fBNg
  CSIDL_COMMON_DOCUMENTS 		=$002e;//Shfolder.dllF AllUsers ̃hLgev[gi[fBNgiWindows NT n Shfolder.dll CXg[ꂽ Windows 9xj
  CSIDL_COMMON_ADMINTOOLS 		=$002f;//Version 5.0 ȍ~F AllUsers ̊Ǘc[fBNg
  CSIDL_ADMINTOOLS 		=$0030;//Version 5.0 ȍ~F Ǘc[fBNg

function GetSpecialFolder(id: DWORD): string;
var
  PID: PItemIDList;
  Path: array[0..MAX_PATH-1] of Char;
begin
  SHGetSpecialFolderLocation(GetDesktopWindow, id, PID);
  SHGetPathFromIDList(PID, Path);
  Result := Path;
  if Copy(Result, Length(Result),1)<>'\' then Result := Result + '\';
end;

{WindowstH_𓾂}
function WinDir:string;
var
 TempWin:array[0..MAX_PATH] of Char;
begin
 GetWindowsDirectory(TempWin,MAX_PATH);
 Result:=StrPas(TempWin);
 if Copy(Result,Length(Result),1)<>'\' then Result := Result + '\';
end;

{SystemtH_𓾂}
function SysDir:string;
var
 TempSys:array[0..MAX_PATH] of Char;
begin
 GetSystemDirectory(TempSys,MAX_PATH);
 Result:=StrPas(TempSys);
 if Copy(Result,Length(Result),1)<>'\' then Result := Result + '\';
end;

{TemptH_𓾂}
function TempDir:string;
var
 TempTmp:array[0..MAX_PATH] of Char;
begin
 GetTemppath(MAX_PATH,TempTmp);
 Result:=StrPas(TempTmp);
 if Copy(Result,Length(Result),1)<>'\' then Result := Result + '\';
end;

function DesktopDir:string;
begin
   Result := GetSpecialFolder(CSIDL_DESKTOPDIRECTORY);
end;
function SendToDir:string;
begin
   Result := GetSpecialFolder(CSIDL_SENDTO);
end;
function StartUpDir:string;
begin
   Result := GetSpecialFolder(CSIDL_STARTUP);
end;
function RecentDir:string;
begin
   Result := GetSpecialFolder(CSIDL_RECENT);
end;
function ProgramsDir:string;
begin
   Result := GetSpecialFolder(CSIDL_PROGRAMS);
end;
function StartMenuDir:string;
begin
   Result := GetSpecialFolder(CSIDL_STARTMENU);
end;
function MyDocumentDir:string;
begin
   Result := GetSpecialFolder(CSIDL_PERSONAL);
end;
function FavoritesDir: string;
begin
   Result := GetSpecialFolder(CSIDL_FAVORITES);
end;
function MyMusicDir:string;
begin
   Result := GetSpecialFolder(CSIDL_MYMUSIC);
end;
function MyPictureDir:string;
begin
   Result := GetSpecialFolder(CSIDL_MYPICTURES);
end;
function FontsDir: string;
begin
   Result := GetSpecialFolder(CSIDL_FONTS);
end;
function ProgramFilesDir:string;
begin
   Result := GetSpecialFolder(CSIDL_PROGRAM_FILES);
end;

//-------------------------------------------------------------------------
function CheckFilter(Filter: string): string;
begin
  if Pos('|', Filter) = 0 then
  begin
    if Filter = '' then Filter := 'SẴt@C(*.*)|*.*'
    else begin
      if Pos('.', Filter) = 0 then Filter := '.' + Filter;
      if Pos('*', Filter) = 0 then Filter := '*' + Filter;
      Filter := '(' + Filter + ') `|' + Filter + '|SẴt@C(*.*)|*.*';
    end;
  end;
  Result := Filter;
end;

function ReplaceChar(const s: string; fromCH, toCH: Char): string;
var
  i: Integer;
begin
  Result := s;
  i := 1;
  while i <= Length(s) do
  begin
    if Result[i] in LeadBytes then
    begin
      Inc(i, 2);
    end else
    begin
      if Result[i] = fromCH then Result[i] := toCH;
      Inc(i);
    end;
  end;
end;

function ShowOpenDialog(hOwner:HWND; Filter, InitDir: string): string;
var
  OFN: TOpenFileName;
  PATH, s, res: string;
  p: PChar;
begin
  PATH := #0;
  SetLength(PATH,MAX_PATH+5);
  //----------------------------------------------------------------------------
  // FILTER
  Filter := CheckFilter(Filter);
  Filter := ReplaceChar(Filter, '|', #0)+#0;

  // OpenFileName \̂ɃZbg
  FillChar(OFN,SizeOf(OFN),0);
  with OFN do
  begin
    lStructSize := 76; // for Delphi6
    hWndOwner := hOwner;
    lpstrFilter := PChar(Filter);
    nFilterIndex := 1;
    lpstrFile := PChar(PATH);
    nMaxFile:= MAX_PATH+5;
    lpstrInitialDir := PChar(InitDir);
    Flags := OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_EXPLORER or OFN_ALLOWMULTISELECT;
  end;

  if GetOpenFileName(OFN) then
  begin
    SetLength(res, OFN.nMaxFile);
    ZeroMemory(PChar(res), OFN.nMaxFile);
    StrMove(PChar(res), OFN.lpstrFile, OFN.nMaxFile);

    Result := ''; p := PChar(res);

    // t@C̎o(}`Ή NULL ؂z)
    PATH := getTokenStr(p, #0);
    Inc(p); // skip #0
    if p^ = #0 then
    begin
      Result := Trim(PATH); Exit;
    end;

    while p^ <> #0 do
    begin
      s := getTokenStr(p, #0);
      Result := Result + PATH + '\' + s + #13#10;
      Inc(p); // skip #0
    end;

    Result := Trim(Result);
  end else
  begin
    Result := '';
  end;
end;

(*
function ShowSaveDialog(hOwner:HWND; Filter, InitDir: string): string;
var
  OFN: TOpenFileName;
  PATH: string;
  ext: string;
  extList: TStringList;
begin
  PATH := #0;
  SetLength(PATH,MAX_PATH+5);
  //----------------------------------------------------------------------------
  // FILTER
  Filter := CheckFilter(Filter);
  extList := TStringList.Create;
  extList.SplitText(Filter, '|');
  Filter := ReplaceChar(Filter, '|', #0)+#0;

  // OpenFileName \̂ɃZbg
  FillChar(OFN,SizeOf(OFN),0);
  with OFN do
  begin
    lStructSize := 76; // for Delphi6
    hWndOwner := hOwner;
    lpstrFilter := PChar(Filter);
    nFilterIndex := 1;
    lpstrFile := PChar(PATH);

    nMaxFile:= MAX_PATH+5;
    lpstrInitialDir := PChar(InitDir);
    Flags := OFN_OVERWRITEPROMPT or OFN_HIDEREADONLY;
  end;

  if GetSaveFileName(OFN) then
  begin
    SetLength(Result, OFN.nMaxFile);
    ZeroMemory(PChar(Result), OFN.nMaxFile);
    StrMove(PChar(Result), OFN.lpstrFile, OFN.nMaxFile);

    Result := Trim(string( PChar(Result) ));
    if ExtractFileExt(Result) = '' then
    begin
      ext := extList.Strings[ (OFN.nFilterIndex-1) * 2 + 1 ];
      ext := ExtractFileExt(getToken_s(ext, ';'));
      if (Pos('*', ext) > 0)or(Pos('?', ext) > 0) then ext := '';
      Result := ChangeFileExt(Result, ext);
    end;

  end else
  begin
    Result := '';
  end;
  //
  extList.Free;
end;
*)

{tH_̎Qƃ_CAOpR[obN֐}
function BrowseCallback(hWnd: HWND; uMsg: UINT; lParam: LPARAM; lpData: LPARAM): integer; stdcall;
var
  PathName: array[0..MAX_PATH] of Char;
begin
  Result:=0;

  case uMsg of
  {ŏɕ\tH_}
  BFFM_INITIALIZED:
   SendMessage(hwnd,BFFM_SETSELECTION,1,LongInt(lpData));
  {tH_QƎɃpX\}
  BFFM_SELCHANGED:
   begin
    SHGetPathFromIDList(PItemIDList(lParam), PathName);
    SendMessage(hWnd, BFFM_SETSTATUSTEXT, 0, LongInt(@PathName));
   end;
  end;
end;

{tH_̎Qƃ_CAOJ}
function OpenFolderDialog(var FolderPath: string): boolean;
var
  Malloc: IMalloc;
  BrowseInfo: TBrowseInfo;
  DisplayPath: array[0..MAX_PATH] of Char;
  IDList: PItemIdList;
  Buffer,pFolderPath: PChar;
begin
  Result:=False;

  if Succeeded(SHGetMalloc(Malloc)) then  //IMalloc̃|C^擾ł
  begin
   pFolderPath:=PChar(FolderPath);       //tH_wp

   {BrowseInfo\̂}
   with BrowseInfo do
   begin
    hwndOwner      := GetActiveWindow();  //D4SelectDirectorył́AApplication.HandleɂȂĂ̂ŁA\ʒuȂ
    pidlRoot       := nil;
    pszDisplayName := DisplayPath;                             //\pobt@
    lpszTitle      := 'tH_IĂB';
    ulFlags        := BIF_RETURNONLYFSDIRS{ or BIF_STATUSTEXT};  //ʏ̃tH_̂ݎQƉ\itH_͑IłȂj
    lpfn           := @BrowseCallback;                         //R[obN֐w
    lParam         := LongInt(pFolderPath);                    //tH_w
    iImage         := 0;
   end;

   IDlist := SHBrowseForFolder(BrowseInfo); //tH_Qƃ_CAO\
   if IDlist<>nil then                      //lԂĂ
    begin
     Buffer:=Malloc.Alloc(MAX_PATH);        //tH_pX擾pobt@
     try
      SHGetPathFromIDList(IDlist, Buffer);  //tH_pX擾
      FolderPath:=string(Buffer);
     finally
      Malloc.Free(Buffer);
     end;

     Malloc.Free(IDlist);
     Result:=True;
    end;
  end;
end;


function RunAndWait(path: string; Hide: Boolean): Boolean;
var
  ret: Boolean;
  ecode: Integer;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  Result := False;

  // \Ԃݒ
  with StartupInfo do begin
    // ̍\̂̃TCYw
    cb := SizeOf(TStartupInfo);

    // EBhE̕\Ԃw
    if Hide then
      wShowWindow := SW_HIDE
    else
      wShowWindow := SW_SHOWNORMAL;

    // LȐݒ荀ڂw
    dwFlags := STARTF_USESHOWWINDOW;

    // ȊO̍ڂ
    lpReserved := nil;
    lpDesktop  := nil;
    lpTitle    := nil;
    cbReserved2 := 0;
    lpReserved2 := nil;
  end;
  // s
  ret := CreateProcess(
    nil,                        // st@C
    PChar(path),                // R}hC
    nil,                        // vZX̃ZLeB
    nil,                        // Xbh̃ZLeB
    False,                      // evZXnhp邩
    CREATE_DEFAULT_ERROR_MODE,  // D揇ʂƃvZX̐쐧
    nil,                        // ϐubNւ̃|C^
    nil,                        // JgfBNg
    StartupInfo,                // EBhȆ
    ProcessInfo                 // VvZX̏󂯎\
  );

  // G[`FbN
  if not ret then
  begin
    raise Exception.Create('w'+path+'xsł܂BŔA' + IntToStr(GetLastError) + 'B');
  end;

  // I҂(10b҂)
  ecode := WaitForSingleObject(ProcessInfo.hProcess, INFINITE);

  // bZ[W\
  case ecode of
    WAIT_OBJECT_0:  Result := True;
    WAIT_TIMEOUT :  Result := False;
  end;
end;

initialization
;

finalization
;

end.
