unit unit_file;
//------------------------------------------------------------------------------
// t@Co͂ɊւėpIȃjbg
// [쐬] R{ / NWs
// [A] mine@text2music.com | http://www.text2music.com
// [t] 2004/07/28 : 2005/04/05 ėpIɕύX
//
interface

uses
  Windows, SysUtils, Classes, ShellApi, comobj, shlobj, activex;

type
  TWindowState = (wsNormal, wsMinimized, wsMaximized);

// Ƀt@C̓eSJ
function FileLoadAll(Filename: string): string;

// Ƀt@C̓eS
procedure FileSaveAll(s, Filename: string);

//COPY
function SHFileCopy(const Source, Dest, Title: string): Boolean;
function SHFileDelete(const Source: string): Boolean;
function SHFileDeleteComplete(const Source: string): Boolean;
function SHFileMove(const Source, Dest: string): Boolean;
function SHFileRename(const Source, Dest: string): Boolean;

//EnumFile
function EnumFiles(path: string): TStringList;
function EnumAllFiles(path: string): TStringList;
function EnumDirs(const path: string): TStringList;
function CreateShortCut(SavePath, TargetApp, Arg, WorkDir: string; State: TWindowState): Boolean;

//t@C̍쐬EXVEŏI𓾂
function GetFileTimeEx(fname:string; var tCreation, tLastAccess, tLastWrite:TDateTime):Boolean;
function SetFileTimeEx(fname:string; tCreation, tLastAccess, tLastWrite: TDateTime): Boolean;
//TDateTimet@C𓾂
function DateTimeToFileTimeEx(dt: TDateTime):TFileTime;
// t@C^C[JTTimeDateɕϊ
function FileTimeToDateTimeEx(const ft:TFileTime):TDateTime;

function OpenApp(s: string): Boolean;

var MainWindowHandle: THandle = 0;


implementation

uses unit_string;

function OpenApp(s: string): Boolean;
begin
  ShellExecute(MainWindowHandle, 'open', PChar(s), nil, nil, SW_SHOW);
end;

function CheckPathYen(s: string): string;
begin
  if Copy(s,Length(s),1) <> '\' then s := s + '\';
  Result := s;
end;

function getMainWindowHandle: THandle;
begin
  if MainWindowHandle = 0 then
  begin
    MainWindowHandle := GetForegroundWindow;
  end;

  Result := MainWindowHandle;
end;


// t@C^C[JTTimeDateɕϊ
function FileTimeToDateTimeEx(const ft:TFileTime):TDateTime;
var lt:TFileTime; st:TSystemTime;
begin
  // 2́uȊ֐B vXB27 FftHg̖ F02/10/15 19:24 
  FileTimeToLocalFileTime(ft,lt);
  FileTimeToSystemTime(lt,st);
  Result:=SystemTimeToDateTime(st);
end;

//TDateTimet@C𓾂
function DateTimeToFileTimeEx(dt: TDateTime):TFileTime;
var ft:TFileTime; st:TSystemTime;
begin
  DateTimeToSystemTime(dt, st);
  SystemTimeToFileTime(st, ft);
  LocalFileTimeToFileTime(ft, Result);
end;


//t@C̍쐬EXVEŏI𓾂
function GetFileTimeEx(fname:string; var tCreation, tLastAccess, tLastWrite:TDateTime):boolean;
var
  F: TWin32FindData;
  h:THandle;
begin
  Result:=False;
  h := FindFirstFile(PChar(fname),F);
  if h <> INVALID_HANDLE_VALUE then
  begin
    tCreation   :=  FileTimeToDateTimeEx( F. ftCreationTime   );
    tLastAccess :=  FileTimeToDateTimeEx( F. ftLastAccessTime );
    tLastWrite  :=  FileTimeToDateTimeEx( F. ftLastWriteTime  );
    Windows.FindClose(h);
    Result := True;
  end;
end;

// ꊇŃt@CύX
function SetFileTimeEx(fname:string; tCreation, tLastAccess, tLastWrite: TDateTime): Boolean;
var
  fCreation, fLastAccess, fLastWrite: TFileTime;
  hFile: THandle;
begin
  // ̕ϊ
  fCreation   := DateTimeToFileTimeEx(tCreation   );
  fLastAccess := DateTimeToFileTimeEx(tLastAccess );
  fLastWrite  := DateTimeToFileTimeEx(tLastWrite  );

  // ̕ύX
	hFile := CreateFile(PChar(fname), GENERIC_WRITE, 0, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hFile <> INVALID_HANDLE_VALUE then
  begin
	  SetFileTime(hFile, @fCreation, @fLastAccess, @fLastWrite);
	  CloseHandle(hFile);
    Result := True;
  end else
  begin
    Result := False;
  end;
end;


// Ƀt@C̓eSJ
function FileLoadAll(Filename: string): string;
var
  f: THandle;
  size, rsize: DWORD;
begin
  // open
  f := CreateFile(PChar(Filename), GENERIC_READ, FILE_SHARE_READ, nil,
    OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_SEQUENTIAL_SCAN,0);
  if f = INVALID_HANDLE_VALUE then
    raise EInOutError.Create('t@C"' + Filename + '"J܂B');
  try
    // set pointer
    SetFilePointer(f, 0, nil, FILE_BEGIN); // ߂[̈ʒu

    // read
    size := GetFileSize(f, nil); // 4G ȉ
    SetLength(Result, size);
    if not ReadFile(f, Result[1], size, rsize, nil) then
    begin // s
      raise EInOutError.Create('t@C"' + Filename + '"̓ǂݎɎs܂B');
    end;
  finally
    // close
    CloseHandle(f);
  end;
end;

// Ƀt@C̓eS
procedure FileSaveAll(s, Filename: string);
var
  f: THandle;
  size, rsize: DWORD;
begin
  // open
  f := CreateFile(PChar(Filename), GENERIC_WRITE, 0, nil,
    CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_SEQUENTIAL_SCAN,0);
  if f = INVALID_HANDLE_VALUE then
    raise EInOutError.Create('t@C"' + Filename + '"J܂B');
  try
    // set pointer
    SetFilePointer(f, 0, nil, FILE_BEGIN); // ߂[̈ʒu

    // write
    size := Length(s);
    if size > 0 then
    begin
      if not WriteFile(f, s[1], size, rsize, nil) then
      begin // s
        raise EInOutError.Create('t@C"' + Filename + '"̓ǂݎɎs܂B');
      end;
    end;
  finally
    // close
    CloseHandle(f);
  end;
end;


function SHFileCopy(const Source, Dest, Title: string): Boolean;
var
  foStruct: TSHFileOpStruct;
  s_src, s_des: string;
begin
  Result := False;
  if (Source='')or(Dest='') then Exit;

  s_src := Source + #0#0;
  s_des := Dest   + #0#0;

  with foStruct do
  begin
    wnd    := getMainWindowHandle;
    wFunc  := FO_COPY;            //tOiRs[̏ꍇFO_COPYj
    pFrom  := PChar(s_src);
    pTo    := PChar(s_des);
    fFlags := FOF_MULTIDESTFILES or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR{orFOF_NOERRORUI};
    fAnyOperationsAborted := False;          // fꂽꍇ FALSE Ԃ
    hNameMappings         := nil;            // Õt@C
    lpszProgressTitle     := PChar(Title);   // _CAÕ^Cg
  end;
  Result := (SHFileOperation(foStruct) = 0);
end;

function SHFileDelete(const Source: string): Boolean;
var
  foStruct: TSHFileOpStruct;
begin
  with foStruct do
  begin
    wnd    := getMainWindowHandle;//Application.Handle;
    wFunc  := FO_DELETE;  //tOiRs[̏ꍇFO_COPYj
    pFrom  := PChar(Source + #0#0);  //tH_
    pTo    := Nil; // Kv
    fFlags := FOF_NOCONFIRMATION or FOF_ALLOWUNDO or FOF_MULTIDESTFILES or FOF_NOERRORUI;  //_CAO\
    fAnyOperationsAborted := False;
    hNameMappings         := nil;
    lpszProgressTitle     := nil;
  end;
  Result := (SHFileOperation(foStruct)=0);
end;

function SHFileDeleteComplete(const Source: string): Boolean;
var
  foStruct: TSHFileOpStruct;
begin
  with foStruct do
  begin
    wnd    := getMainWindowHandle;//Application.Handle;
    wFunc  := FO_DELETE;  //tOiRs[̏ꍇFO_COPYj
    pFrom  := PChar(Source + #0#0);  //tH_
    pTo    := Nil; // Kv
    fFlags := FOF_NOCONFIRMATION or FOF_MULTIDESTFILES or FOF_NOERRORUI;  //_CAO\
    fAnyOperationsAborted := False;
    hNameMappings         := nil;
    lpszProgressTitle     := nil;
  end;
  Result := (SHFileOperation(foStruct)=0);
end;

function SHFileMove(const Source, Dest: string): Boolean;
var
  foStruct: TSHFileOpStruct;
begin
  with foStruct do
  begin
    wnd       :=  getMainWindowHandle;//Application.Handle;
    wFunc     :=  FO_MOVE;  //tOiRs[̏ꍇFO_COPYj
    pFrom     :=  PChar(Source + #0#0);  //tH_
    pTo       :=  PChar(Dest   + #0#0);
    fFlags    :=  FOF_NOCONFIRMATION or FOF_ALLOWUNDO or FOF_NOERRORUI;  //_CAO\
    fAnyOperationsAborted := False;
    hNameMappings         := nil;
    lpszProgressTitle     := nil;
  end;
  Result := (SHFileOperation(foStruct)=0);
end;

function SHFileRename(const Source, Dest: string): Boolean;
begin
  Result := SHFileMove(Source, Dest);
end;

function EnumFiles(path: string): TStringList;
var
  rec: TSearchRec;
  basePath: string;
  s: string;

  procedure _enum(path: string);
  begin
    // t@Č
    if FindFirst(path, FaAnyFile, rec) = 0 then
    begin
      repeat
        if not ((rec.Attr and FaDirectory)>0) then
        begin
          Result.Add(rec.Name);
        end;
      until FindNext(rec) <> 0;
      FindClose(rec);
    end;
  end;

begin
  Result := TStringList.Create;

  // path tH_H
  if DirectoryExists(path) then
  begin
    path := CheckPathYen(path);
  end;

  // {pX̔o
  basePath := ExtractFilePath(path);
  if basePath <> '' then
  begin
    System.Delete(path, 1, Length(basePath));
  end;

  // gq;ŋ؂Ă̂;܂ł؂oĂꂼ
  while True do
  begin
    s := getToken_s(path, ';');

    // pXLqĂȂ basePath 𑫂
    if Pos(':\', s) = 0 then s := basePath + s;

    // tH_݂̂̎wȂ ChJ[h𑫂
    if Copy(s, Length(s), 1) = '\' then s := s + '*';

    _enum(s);

    if path = '' then Break;
  end;

end;

function EnumAllFiles(path: string): TStringList;
var
  basePath: string;
  s: string;

  procedure _enum(path: string);
  var
    base, ext, s: string;
    dirs: TStringList;
    files: TStringList;
    i: Integer;
  begin
    // {pX擾
    base := ExtractFilePath(path); base := CheckPathYen(base);
    ext  := ExtractFileName(path);

    // t@C
    files := EnumFiles(path);
    for i := 0 to files.Count - 1 do
    begin
      Result.Add(base + files.Strings[i]); // pXǉČʂɑ
    end;
    files.Free;

    // tH_
    dirs := EnumDirs(base+'*');
    for i := 0 to dirs.Count - 1 do
    begin
      s := base + dirs.Strings[i] + '\' + ext;
      _enum(s); // ċAIɌ
    end;
    dirs.Free;
  end;

begin
  Result := TStringList.Create;

  // path tH_H
  if DirectoryExists(path) then
  begin
    path := CheckPathYen(path);
  end;

  // {pX̔o
  basePath := ExtractFilePath(path);
  if basePath <> '' then System.Delete(path, 1, Length(basePath));

  // gq;ŋ؂Ă̂;܂ł؂oĂꂼ
  while True do
  begin
    s := getToken_s(path, ';');

    // pXLqĂȂ basePath 𑫂
    if Pos(':\', s) = 0 then s := basePath + s;

    // tH_݂̂̎wȂ ChJ[h𑫂
    if Copy(s, Length(s), 1) = '\' then s := s + '*';

    _enum(s);

    if path = '' then Break;
  end;

end;

function EnumDirs(const path: string): TStringList;
var
  rec: TSearchRec;
  s: string;
begin
  Result := TStringList.Create;
  //
  s := path;
  if DirectoryExists(s) then
  begin
    s := CheckPathYen(s) + '*';
  end;
  //
  if FindFirst(s, FaAnyFile, rec) = 0 then
  begin
    repeat
      if ((rec.Attr and FaDirectory) > 0) then
      begin
        if (rec.Name = '.') or (rec.Name = '..') then Continue;
        Result.Add(rec.Name);
      end;
    until FindNext(rec) <> 0;
    FindClose(rec);
  end;
end;

function CreateShortCut(SavePath, TargetApp, Arg, WorkDir: string; State: TWindowState): Boolean;
var
  IU: IUnknown;
  W: PWideChar;
const
  ShowCmd: array[TWindowState] of Integer =
    (SW_SHOWNORMAL, SW_MINIMIZE, SW_MAXIMIZE);
begin
  Result := False;
  try
    IU := CreateComObject(CLSID_ShellLink);
    with IU as IShellLink do begin
      if SetPath(PChar(TargetApp)) <> NOERROR then Abort;
      if SetArguments(PChar(Arg)) <> NOERROR then Abort;
      if SetWorkingDirectory(PChar(WorkDir)) <> NOERROR then Abort;
      if SetShowCmd(ShowCmd[State]) <> NOERROR then Abort
    end;
    W := PWChar(WideString(SavePath));
    if (IU as IPersistFile).Save(W, False) <> S_OK then Abort;
    Result := True
  except
  end
end;

end.
